#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAX_GAMES 100

/*The program implements a 3-doors game*/
int main()
{

	int strategy, max_runs, run, countGames=0;
	int winningDoor, selectedDoor, openingDoor, toSwitch, isWinning;

	srand(time(NULL));
	printf("Please enter a strategy:\n1) Run the game with input from the user\n2) Run the game with switches strategy\n3) Run the game with none-switches strategy\n");
	scanf("%d", &strategy);
	while(strategy < 1 || strategy > 3){
		printf("Your selection is not valid!, make a new one.\n");
		scanf("%d", &strategy);
	}

	if(strategy == 1) 
		max_runs = 1;
	else
		max_runs = MAX_GAMES;
	

	
	for(run=0; run < max_runs; run++)
	{
		//choose a random door as a winning door
		winningDoor = rand()%3+1;	

		if(strategy == 1){ 
			//gets a door selection from the user
			printf("Please choose a door: 1,2,3\n");
			scanf("%d", &selectedDoor);
			while(selectedDoor < 1 || selectedDoor > 3){
				printf("Your selection is not valid!, make a new one.\n");
				scanf("%d", &selectedDoor);
			}
		}
		else
			//choose a random door as a selected door
			selectedDoor = rand()%3+1;

		//choose an empty door to open
		openingDoor = rand()%3+1;
		while(openingDoor == winningDoor || openingDoor == selectedDoor)
			openingDoor = rand()%3+1;
	

		if(strategy == 1){	
			//asks the user if he wants to change his selection
			printf("Door %d is empty.\n", openingDoor);
			printf("Do you want to switch your door?  (1 - yes , 0 - no)\n");
			scanf("%d", &toSwitch);
			while(toSwitch != 0 && toSwitch != 1){
				printf("Your selection is not valid!, make a new one.\n");
				scanf("%d", &toSwitch);
			}
		}
		else if(strategy == 2)
			toSwitch = 1;
		else
			toSwitch = 0;



		if(toSwitch){
			//find the number of the new switched door
			if(selectedDoor == 1 && openingDoor == 2) 
				selectedDoor = 3;
			else if(selectedDoor == 1 && openingDoor == 3) 
				selectedDoor = 2;
			else if(selectedDoor == 2 && openingDoor == 1) 
				selectedDoor = 3;
			else if(selectedDoor == 2 && openingDoor == 3) 
				selectedDoor = 1;
			else if(selectedDoor == 3 && openingDoor == 1) 
				selectedDoor = 2;
			else if(selectedDoor == 3 && openingDoor == 2) 
				selectedDoor = 1;
		}

		isWinning = (winningDoor == selectedDoor);

		countGames+=isWinning;

		if(strategy == 1 && isWinning)
			printf("You won!!!\n");
		else if (strategy == 1 && !isWinning)
			printf("You lost.\n");
	}//for

	if(strategy == 2)
		printf("The probability to win with switches strategy is: %g\n", countGames/(double)MAX_GAMES);
	else if(strategy == 3)
		printf("The probability to win without switches strategy is: %g\n", countGames/(double)MAX_GAMES);


			
	return 0;
}





